#ifndef _GENERATEUR_H_
	#define _GENERATEUR_H_

#include <stdio.h>
#include "utilities.h"

typedef struct attribut {
	char* nom;
	char* type;
	struct liste *contraintes;
}Attribut;


typedef struct pile {
	int cpt;
	char* str;
	struct attribut* attr[10];
	struct attribut* elem[10];
	int nbattr;
	int nbelem;
	struct pile* precedent;
	struct pile* suivant;
}Pile;
Pile* ClassName;
Pile* ClassNameBottom;


extern FILE *header, *source;

void init();


void creer_classe(char* name);
void finir_classe();

void attribute(char* name, char* type);
void attribute_contraint(char* name, char* type,struct liste *l);
void ecrire_attributs();

void ajouter_element(char* name);
void finir_element();

void indent(int i);
void indentxml();

int already_done_element(char* name);

Pile* rechercher(char* name);

#endif
